

int access_whandle;
int access_rhandle;
int access_mhandle;
int access_file;
int access_recurse;

int access_rof;
int access_wpw;
int access_rpw;
int access_rof2;
int access_wpw2;
int access_rpw2;



void access_mclose(int handle)
{
 if(access_mhandle)
 {
  close_window(access_mhandle);
  delete_window(access_mhandle);
  access_mhandle=0;
 }
}


// open 'Access' dialogue box

int access_entry(int entry,int subcode)
{
 int bits;
 int locked;


 if(access_mhandle) access_mclose(access_mhandle);

 access_mhandle=create_windowparent("access_m",viewhandle(currentview()));
 addwindowhandler(0, access_mhandle,"access_click");
 addwindowhandler(1, access_mhandle,"access_key");
 addwindowhandler(7,access_mhandle,"access_mclose");

 bits=password("","",0,currentfile());

 access_rof=bits & (1<<8);
 access_wpw=bits & (1<<1);
 access_rpw=bits & (1<<0);
 access_rof2=access_rof;
 access_wpw2=access_wpw;
 access_rpw2=access_rpw;
 locked=(bits & (1 << 5))==0;

 select_icon(access_mhandle,21,access_rof);
 select_icon(access_mhandle,22,access_wpw);
 select_icon(access_mhandle, 3,access_rpw);

 access_file=currentfile();
 writeicon(access_mhandle,4,"");
 writeicon(access_mhandle,5,"");
 set_icon_state(access_mhandle,22,(1 << 22) * locked, (1 << 22));
 set_icon_state(access_mhandle, 3,(1 << 22) * locked, (1 << 22));
 set_icon_state(access_mhandle, 4,(1 << 22) * locked, (1 << 22));
 set_icon_state(access_mhandle, 5,(1 << 22) * locked, (1 << 22));
 display_window(access_mhandle, 0,1);
 if(!locked) insert_caret(access_mhandle,4);

 return(0);
}


// deal with OK button on Read box

void access_readok(int handle)
{
 int b;
 string p;

 p=readicon(handle,21);
 if(p!="") password(p, p, 1 | (1 << 3) | (1 << 4), access_file);
 b = password("", "", 0, access_file);
 if(b & (1 << 2))
 {
  close_window(handle);
  access_recurse = 0;
  setcurrentfile(access_file);
  newview(0);
 }
 else
 {
  messagebox("Incorrect password");
 }
}


// deal with Cancel button on Read box

void access_readcancel(int handle)
{
 filescrap(access_file);
 close_window(handle);
 access_recurse=0;
}


void access_wclose(int handle)
{
 if(handle)
 {
  close_window(handle);
  delete_window(handle);
  access_whandle=0;
 }
 access_recurse=0;
}


// deal with OK button on Write box

void access_writeok(int handle)
{
 int b;
 string p;

 p=readicon(handle,21);
 password("",p,1 | (1<<4),access_file);
 b=password("","",0,access_file);
 if(b & (1<<5))
 {
  access_wclose(handle);
  messagebox("Write protect unlocked");
 }
 else
  messagebox("Incorrect password");
}


// deal with Cancel button on Write box

void access_writecancel(int handle)
{
 access_wclose(handle);
}




// deal with OK button on main box

void access_mainok(int handle)
{
 string wpw, rpw;
 int rofb, wpwb, rpwb;

 wpw = readicon(handle, 4);
 rpw = readicon(handle, 5);

 access_rof = access_rof2;
 access_wpw = access_wpw2;
 access_rpw = access_rpw2;

 rofb = access_rof != 0;
 wpwb = (access_wpw && wpw != "") || !access_wpw;
 rpwb = (access_rpw && rpw != "") || !access_rpw;

 password(rpw, wpw, 2 | (rpwb << 3) | (wpwb << 4) | (1 << 5) | (rofb << 8), currentfile());
 access_mclose(handle);
}


// deal with clicks on buttons

void access_click(int handle, int icon, int bits, int mx, int my)
{
 string p;

 if(handle==access_rhandle)
 {
  if(icon==1) access_readok(handle);
  if(icon==2) access_readcancel(handle);
 }

 if(handle==access_whandle)
 {
  if(icon==1) access_writeok(handle);
  if(icon==2) access_writecancel(handle);
 }

 if(handle==access_mhandle)
 {
  if(icon==21) select_icon(access_mhandle,21,access_rof2=!access_rof2);
  if(icon==22) select_icon(access_mhandle,22,access_wpw2= !access_wpw2);
  if(icon==3) select_icon(access_mhandle,3,access_rpw2= !access_rpw2);
  if(icon==1) access_mainok(access_mhandle);
  if(icon==2) access_mclose(access_mhandle);
 }
}


// deal with Return being pressed in dialogue boxes

int access_key(int handle, int icon, int key)
{
 if(handle==access_rhandle && icon==21 && key==13) access_readok(handle);
 else
 if(handle==access_whandle && icon==21 && key==13) access_writeok(handle);
 else
 if(handle==access_mhandle && icon==5 && key==13) access_mainok(handle);
 else return(key);

 return(-1);
}


// event handler for 'read password' protected documents

int access_filenoread(int user, int file, int claimed)
{
 if(access_recurse)
  return(claimed);

 access_recurse=1;
 access_file=file;
 writeicon(access_rhandle,21,"");
 display_window(access_rhandle, 0, 1);
 insert_caret(access_rhandle,21);
 return(1);
}


// event handler for 'write password' protected documents

int access_filewritefail(int user, int file, int claimed)
{
 int b;

 if(access_recurse)
  return(claimed);

 b = password("", "",0,file);
 if(!(b & (1<<5)))
 {
  access_recurse=1;
  access_file=file;
  access_whandle=create_window("access_w");
  addwindowhandler(0,access_whandle,"access_click");
  addwindowhandler(1,access_whandle,"access_key");
  addwindowhandler(7,access_whandle,"access_wclose");

  writeicon(access_whandle,21,"");
  display_window(access_whandle,0,1);
  insert_caret(access_whandle,21);
 }
 return(1);
}


// close dialogue boxes when attached document is closed

int access_filescrap(int user, int file, int claimed)
{
 if(file==access_file)
 {
  access_writecancel(access_whandle);
  access_mclose(access_mhandle);
 }
 return(claimed);
}


// close dialogue boxes when there is a click in the attached document

int access_viewclick(int user, int view, int mousex, int mousey, int mousebuttons)
{
 if(filefromview(view)==access_file)
 {
  access_writecancel(access_whandle);
  access_mclose(access_mhandle);
 }
 return(mousebuttons);
}


// create 'Access' option and add it to 'Applets' menu

void main(void)
{
 script_menu_initialise();

 script_menu_insert("access_entry","","","","{ACCESS_00}");

 access_rhandle=create_window("access_r");
 addwindowhandler(0,access_rhandle,"access_click");
 addwindowhandler(1,access_rhandle,"access_key");



 addeventhandler(0x307,0,"access_filenoread");
 addeventhandler(0x308,0,"access_filewritefail");
 addeventhandler(0x309,0,"access_filescrap");
 addeventhandler(0x213,0,"access_viewclick");
}
