/*->c.colsep */




#include "stdafx.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h> 

#include "os.h"
#include "bbc.h"
#include "sprite.h"
#include "wimp.h"

#include "transform.h"

#include "xprocess.h"



#include "wos.h"
#include "poll.h"
#include "etc.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "sp.h"
#include "task.h"
#include "xhelp.h"
#include "trans.h"
#include "dbhi.h"
#include "key.h"
#include "temp.h"

#include "xext.h"



#include "constants.h"
#include "str.h"


#include "file.h"
#include "view.h"
#include "viewo.h"

#include "xxcolour.h"

#include "units.h"

#include "object.h"
#include "select.h"

#include "dbscale.h"
#include "scripts.h"




#include "colsep.h"
#include "colseplink.h"


#include "csstr.h"
#include "csink.h"
#include "cscurve.h"
#include "csink.h"
#include "csview.h"
#include "cssp.h"
#include "cschoice.h"
#include "dbcolsep.h"
#include "dbprocess.h"
#include "csprocess.h"
#include "xpr.h"
#include "csprint.h"
#include "colcode.h"
#include "icc.h"

#include "colsepx.h"



static HANDLE modulehandle;


char * colsepbasepath;  /* <OvationPro$AppletsDir> */
char * colseppath="<HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders\\AppData>\\DavidPilling\\OvationPro\\Applets";



#define XFNS 37
         

static fndefn fntable[XFNS]=
{

 "csplatebits",(extfn)csplatebits,"IIII",PINT,4,
 "csplatename",(extfn)csplatename,"IRI",PINT,3,
 "csviewname",(extfn)csviewname,"IRI",PINT,3,
 "csviewbits",(extfn)csviewbits,"IIII",PINT,4,
 "cscurvename",(extfn)cscurvename,"IR",PINT,2, 
 "cschoices",(extfn)cschoices,"RRII",PVOID,4,
 "cschoices2",(extfn)cschoices2,"IIIIR",PVOID,5,
 "cschoices3",(extfn)cschoices3,"IIII",PVOID,4,
 "cschoices4",(extfn)cschoices4,"IIII",PINT,4,
 "cschoices5",(extfn)cschoices5,"RRRR",PVOID,4,
 "cschoices6",(extfn)cschoices6,"RRRR",PVOID,4,
 "cschoices7",(extfn)cschoices7,"IIIIII",PVOID,6,
 "cssetcurve",(extfn)cssetcurve,"I",PVOID,1,
 "csinkname",(extfn)csinkname,"IR",PINT,2,
 "cssetink",(extfn)cssetink,"I",PVOID,1,
 "openprocessbox",(extfn)openprocessbox,NULL,PVOID,0,
 "cssetspot",(extfn)cssetspot,"I",PVOID,1,
 "csgetspot",(extfn)csgetspot,NULL,PINT,0,
 "csreadfrequency",(extfn)csreadfrequency,NULL,PINT,0,
 "csreadangle",(extfn)csreadangle,NULL,PINT,0,
 "csreadpsscreen",(extfn)csreadpsscreen,NULL,PINT,0,
 "csreadspot",(extfn)csreadspot,NULL,PINT,0,
 "csreadseps",(extfn)csreadseps,NULL,PINT,0,
 "csreadcolour",(extfn)csreadcolour,"R",PINT,1,
 "openscreenbox",(extfn)openscreenbox,NULL,PVOID,0,
 "csreadpxangle",(extfn)csreadpxangle,NULL,PINT,0,
 "csreadpxpsscreen",(extfn)csreadpxpsscreen,NULL,PINT,0,
 "csreadpxspot",(extfn)csreadpxspot,NULL,PINT,0,
 "csreadpxfrequency",(extfn)csreadpxfrequency,NULL,PINT,0,
 "csgetink",(extfn)csgetink,NULL,PINT,0,
 "csgetcurve",(extfn)csgetcurve,NULL,PINT,0,

 "csprofilename",(extfn)csprofilename,"IRII",PINT,4,
 "cssetprofile",(extfn)cssetprofile,"II",PVOID,2,
 "csgetprofile",(extfn)csgetprofile,"I",PINT,1,
 "cssetintent",(extfn)cssetintent,"II",PVOID,2,
 "csgetintent",(extfn)csgetintent,"I",PINT,1,


 NULL,NULL,NULL,0,0
};




static xfnlink fnlink;


static os_error * scriptevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_SCRIPTINIT,scriptevent,0);
 return(addsymboltable(fntable,&fnlink));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}





static templates temptable[]=
{
 TSEPARATIONS,1,0,"Separations",
 TSCREEN,1,0,"Screen",
 TPLATES,1,0,"Plates",
 TPROCESS,1,0,"Process",
 TCSCHOICE,1,0,"Ch_Colour",
	TICCSETUP,1,0,"ICCSETUP",
 TLAST,0,0,""
};


static templink templatelink;




static os_error * templatesevent(int eventn,int userhandle,
                                                    void * data,int data1)
{
 remevent(EVENT_LOADTEMPLATES,templatesevent,0);

 return(addtemplates2(NULL,NULL,temptable,&templatelink,(ascaninstance)modulehandle));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}



static os_error * spriteevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_LOADSPRITES,spriteevent,0);
 return(addspritesx(colsepbasepath,"ColSupp\\Resources\\Sprites.spr"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}







static os_error * messevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_LOADMESSAGES,messevent,0);
 return(addtranstable(colsepbasepath,"ColSupp\\Resources\\Messages.txt"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}



static os_error * helpevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_LOADHELP,helpevent,0);
 return(addhelp(colsepbasepath,"ColSupp\\Resources\\Help.txt"));

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}









static scripteventstr scriptevents[]=
{
 0,0,0,0, EVENT_PRSTARTSEPARATION,   "1I",
 0,0,0,0, EVENT_PRENDSEPARATION,     "1I",
 0,0,0,0, EVENT_PRSTARTPICT,         "1I",
 0,0,0,0, EVENT_PRENDPICT,           "1I",

};




static os_error * cseventinit(void)
{
 return(registerscripteventblock(scriptevents,
                                 sizeof(scriptevents)/sizeof(scripteventstr)));
}





static os_error * runevent(int eventn,int userhandle,void * data,int data1)
{
 remevent(EVENT_RUNPROGRAM2,runevent,0);

 cschoiceinit();
 csloadcurves(colsepbasepath);
 csinkinit(colsepbasepath);
 csiccinit();
 cseventinit();

 return(NULL);

 USE(eventn);
 USE(userhandle);
 USE(data);
 USE(data1);
}





static colsepblockstr colsepblock=
{
 colsepopen,
 colsepprint,
 xcolseprgb2hsv,
 xcolsephsv2rgb,
 xcolseprgb2cmyk,
 xcolsepcmyk2rgb,
 setprocess,
 deleteprocess,
 copyprocessm,
 dswriteprocess,
 defltprocess,
 cmpprocess,
 colseppict,
 colsepcurrentplate,
 colsepprocess,
 csgetspotinfo,
 xcolsepcmyk2rgb3232,
 csopenscreen,
 xcolsepcmyk2bgr3232,
 
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,
 NULL,

};






extern "C" __declspec(dllexport) os_error * entrypoint(char* path)
{ 
 os_error * err;

 colsepbasepath=path;

          err=addevent(EVENT_LOADTEMPLATES,templatesevent,0);
 if(!err) err=addevent(EVENT_SCRIPTINIT,scriptevent,0);
 if(!err) err=addevent(EVENT_LOADMESSAGES,messevent,0);
 if(!err) err=addevent(EVENT_LOADHELP,helpevent,0);
 if(!err) err=addevent(EVENT_COLOURCHANGE,(eventfn)csviewevent,0);
 if(!err) err=addevent(EVENT_DDLEND,(eventfn)csviewevent2,0);
 if(!err) err=addevent(EVENT_VOPEN,(eventfn)csnewviewevent,0);
 if(!err) err=addevent(EVENT_NEWCOLOURMODEL,(eventfn)csnewcolourmodel,0);
 if(!err) err=addevent(EVENT_RUNPROGRAM2,runevent,0);
 if(!err) err=addevent(EVENT_LOADSPRITES,spriteevent,0);

 if(!err) err=addevent(EVENT_MKSTYLE2,(eventfn)csmkstyle,0);
 if(!err) err=addevent(EVENT_NEWDOC2,(eventfn)csnewevent,0);
 if(!err) err=addevent(EVENT_BAREDOC2,(eventfn)csbareevent,0);

 if(!err) err=registercolsep(&colsepblock);
 if(!err) err=csspinit();
 if(!err) err=xprocessinit();
 if(!err) err=csprintinit();

 return(err);
}







extern "C" BOOL __stdcall _DllMainCRTStartup( 
    HINSTANCE hinstDLL,     // handle to DLL module 
    DWORD fdwReason,        // reason for calling function 
    LPVOID lpvReserved)     // reserved 
{
 
 modulehandle=(HMODULE)hinstDLL;
 return(TRUE);
}


